<template>
  <v-row class="sidebar border-0 ma-0 pa-0">
    <v-col cols="8" class="d-flex align-center justify-center bg-grey-darken-1">
      <v-img class="logo" :src="Logo"/>
    </v-col>
    <v-col cols="4" class="border-0 pa-0 ma-0 ">
      <v-sheet class="sidebar align-content-center">
        <v-card class="text-center" title="Login" variant="flat">
            <v-alert v-if="errors" closable>
              {{ errorMessages }}
            </v-alert>
          <v-card-text>
            <v-form @keyup.enter="login" @submit.prevent>
              <v-text-field v-model="username" type="input" label="Username" variant="outlined" clearable></v-text-field>
              <v-text-field v-model="password" type="password" label="Password" variant="outlined" clearable></v-text-field>
            </v-form>
            <router-link to="#">Forgot Password?</router-link>
          </v-card-text>
          <v-card-actions>
            <v-btn :loading="loading" color="primary" text="Sign In" @click="login" block variant="elevated"></v-btn>
          </v-card-actions>
        </v-card>
      </v-sheet>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import Logo from "../assets/5058_Red_Moose_Technologies_LLC_logo_VP-05.png"
import { ref, inject } from 'vue'
import {AxiosInstance, isAxiosError} from "axios";

const http: AxiosInstance = inject('http')
const username = ref<string>('')
const password = ref<string>('')
const errors = ref<boolean>(false)
const loading = ref<boolean>(false)
const errorMessages = ref<string>("")


async function login() {
  loading.value = true
  http.post("/api/v1/accounts/login", {
    username: username.value,
    password: password.value,
  }).then((response) => {
    if (response.status === 200) {
      loading.value = false
      window.location.href = window.location.port ? `${window.location.protocol}//${window.location.hostname}:${window.location.port}/` : `${window.location.protocol}//${window.location.hostname}/`
    }
  }).catch((error) => {
    if (isAxiosError(error)) {
      if (error.response.status === 404) {
        errors.value = true
        errorMessages.value = "User not found"
      } else if (error.status === 400) {
        console.log(error)
      } else {
        console.log(error)
      }
    }
    loading.value = false
  })


}
</script>

<style scoped>
.sidebar {
  height: 100%;
}

.logo {
  height: 30%;
}
</style>
